(function() {
	tpl.at = {};
	
	//
	// Add the titles of the test cases to the list to get them loaded to the table view
	//
	tpl.at.createData = function () {
		var acceptanceData = [
			{title:'timob2849', hasChild:true, level:'acceptance'},
			{title:'timob4314', hasChild:true, level:'acceptance'},
			{title:'timob4691', hasChild:true, level:'acceptance'},
			{title:'timob5807', hasChild:true, level:'acceptance'},
			{title:'timob6411', hasChild:true, level:'acceptance'},
			{title:'timob6973', hasChild:true, level:'acceptance'},
			{title:'timob6828', hasChild:true, level:'acceptance'},
			{title:'timob7264', hasChild:true, level:'acceptance'}
		]
		
		return acceptanceData;
	};
	
	// TIMOB-5807: Returned values should not return null
	tpl.at.timob5807 = function(_window) {
		var url = 'http://tools.dynamicdrive.com/password/example/';
		var request = Titanium.Network.createHTTPClient();
		request.open('GET',url);
		
		//Send
		request.send();
		
		request.onerror = function() {
			if (this.status == 401) {
				var result = 'Server: ' + this.getResponseHeader('Server') + '\n\n' +
			 				 'Connection: ' + this.getResponseHeader('Connection') + '\n\n' +
			 	    		 'WWW-Authenticate: ' +this.getResponseHeader('WWW-Authenticate') + '\n\n' +
			 	    		 'Date: ' + this.getResponseHeader('Date');
				
				var resultLabel = Ti.UI.createLabel({
					text:result,
					height:'auto',
					width:'auto'
				});
			 	
			 	_window.add(resultLabel);
			 }
		}
		
		return _window;
	}
	
	tpl.at.timob4691 = function (_window) {
		_window.backgroundColor = 'red';
		
		var btn = Ti.UI.createButton({
			title:'Get Cache',
			width:200,
			height:30
		});
		
		btn.addEventListener('click', function(){
			var win2 = Ti.UI.createWindow({
				backgroundColor:'blue'
			});
			var btn2 = Ti.UI.createButton({
				title:'close'
			});
			win2.rightNavButton = btn2;
			btn2.addEventListener('click', function(){win2.close();});
			var img = Ti.UI.createImageView({
				top:0,
				right:0,
				left:0,
				bottom:0,
				image:''
			});
			win2.add(img);
			win2.open({modal:true})
			var xhr = Ti.Network.createHTTPClient();
			xhr.onload = function(){
				img.image = this.responseData;
			}
			xhr.open('GET', 'http://jefflynchdev.files.wordpress.com/2009/10/flag_mountain_view_large.jpg');
			xhr.send();
			
		});
		
		_window.add(btn);
		
		return _window;
	};
	
	tpl.at.timob4314 = function(_window){ 
		  
		var webView = Titanium.UI.createWebView({
		    html: '<select name="selectBox"><option value="val1">Value 1</option><option value="val2">Value 2</option><option value="val3">Value 3</option></select>'
		});
		
		_window.add(webView);
		
		webView.setBasicAuthentication('user','pass');
		
		return _window;
	};
	
	//
	// TIMOB-2849 is designed to test set cookie response headers, specifically on Android 
	//
	tpl.at.timob2849 = function(_window){ 
		  
		var testServer = 'http://appc.me/Test/Cookies/';

		//
		// Create a text area to show responses from the server.
		//
		var response = Titanium.UI.createTextArea({
			left : 0,
			right : 0,
			top : 0,
			bottom : 30,
			value : 'Click a button below, and the response from the server will show up here!'
		});
		_window.add(response);

		//
		// Create a button that will hit a page on a test server that echoes any cookies we send it, or sends us two cookies.
		//
		var getOrSetCookies = Titanium.UI.createButton({
			title : 'Get or Set Cookies',
			left : 0,
			bottom : 0,
			width : 150,
			height : 30
		});
		getOrSetCookies.addEventListener('click', function(e) {
			var xhr = Ti.Network.createHTTPClient();
			xhr.onload = function(e) {
				response.value = this.responseText + '\n\nthis.getResponseHeader(\'Set-Cookie\'): ' + this.getResponseHeader('Set-Cookie');
			};
			xhr.open('GET', testServer + '?count=2&clear=false');
			xhr.send();
		});
		_window.add(getOrSetCookies);

		//
		// Create a button that will clear the cookies on the server (set them to expire). It will tell us how many were cleared.
		//
		var clearCookies = Titanium.UI.createButton({
			title : 'Clear Cookies',
			right : 0,
			bottom : 0,
			width : 150,
			height : 30
		});
		clearCookies.addEventListener('click', function(e) {
			var xhr = Ti.Network.createHTTPClient();
			xhr.onload = function(e) {
				response.value = this.responseText + '\n\nthis.getResponseHeader(\'Set-Cookie\'): ' + this.getResponseHeader('Set-Cookie');
			};
			xhr.open('GET', testServer + '?count=2&clear=true');
			xhr.send();
		});
		_window.add(clearCookies);
		
		return _window;
	}
	
	/* TIMOB-6411 is designed to test that HTTPClient on Android isn't outputting
	 * alot of useless errors
	 * 
	 */
	tpl.at.timob6411 = function(_window) {
		
		var xhr = Titanium.Network.createHTTPClient();
		xhr.open('GET', 'http://www.google.com');
		xhr.send();

		return _window;
	}
	
	//TIMOB-6973: test sending a blob as form data does not fail
	tpl.at.timob6973 = function(_window) {
		
		var xhr = Ti.Network.createHTTPClient({
			onload: function() {
				Ti.API.debug('onload');
				Ti.API.debug(this.responseText);	
			},
			onerror: function() {
				Ti.API.debug('onerror');	
			}	
		});
		xhr.setTimeout = 1600000;
		xhr.open('POST', 'http://savagelook.com/xhr_test.php');
		xhr.setRequestHeader("ContentType","multipart/form-data");
		xhr.send({
			somevar: 1,
			someother: 'yoyo',
			blobtest: Ti.UI.createImageView({
				image: 'KS_nav_ui.png',
				height: 200,
				width: 200
			}).toBlob()
		});
		
		return _window;
	};
	
	//TIMOB-6828: Setting request header in HTTPClient to null throws exception

	tpl.at.timob6828 = function(_window) {
		var xhr = Titanium.Network.createHTTPClient();
		xhr.onerror = function(e) {
			alert("ERROR " + e.error);
		};
		xhr.onload = function() {
			alert("Loaded");
		};

		xhr.open('GET', 'http://www.appcelerator.com');
		xhr.setRequestHeader('Authorization', null);
		xhr.send();

		return _window;
	};

// TIMOB-7264: Android: HTTPClient not working for upload files (Parity)
		tpl.at.timob7264 = function(_window) {
		var win = _window;

		
		var image = Titanium.Filesystem.getFile(Titanium.Filesystem.resourcesDirectory,'appc.jpg');
			
		var xhr = Titanium.Network.createHTTPClient();
		
		xhr.onerror = function(e)
		{
			Ti.UI.createAlertDialog({title:'Error', message:e.error}).show();
			Ti.API.info('IN ERROR ' + e.error);
		};
		xhr.setTimeout(20000);
		xhr.onload = function(e)
		{
			Ti.UI.createAlertDialog({title:'Success', message:'status code ' + this.status}).show();
			Ti.API.info('IN ONLOAD ' + this.status + ' readyState ' + this.readyState);
		};
		xhr.onsendstream = function(e)
		{
			Ti.API.info('ONSENDSTREAM - PROGRESS: ' + e.progress);
		};
		
		// open the client
		xhr.open('POST','https://twitpic.com/api/uploadAndPost');
		
		// send the data
		xhr.send({media:image,username:'fgsandford1000',password:'sanford1000',message:'check me out'});
		
		
		return _window;
	}

})();